/*
 * ----------------------------------------------------------------
 * 
 *     Hongi Editor Lite 2.1
 *
 * This product is under public domain
 *
 * ----------------------------------------------------------------
 */



var hongi_editor_history_limit = 32; //履歴リングバッファの上限、定数扱い
var hongi_editor_history_rings = new Array();
var hongi_editor_history_current = new Array();
var hongi_editor_history_latest = new Array();
var hongi_editor_history_oldest = new Array();

var hongi_editor_key_upped = true;
var hongi_editor_key_downed = false;

var hongi_editor_latest_key_is_delete = false;

var hongi_editor_include_cnt = 0;
var hongi_editor_name = new Array();

document.execCommand("styleWithCSS",true,true);

var hongi_editor_script_elm = document.getElementsByTagName("script");
var hongi_editor_dir_path = hongi_editor_script_elm[hongi_editor_script_elm.length - 1].src.slice(0,-7);/*7は「main.js」の文字数*/

var hongi_editor_lite_toolbar;
var hongi_editor_toolbar_visible = false;

var hongi_editor_screen;

var hongi_editor_wysiwyg_active = 0;

var hongi_editor_browse_image_function = "";

var hongi_editor_font_family_list = new Array("sans-serif","serif");
var hongi_editor_font_name_list = new Array("ゴシック体(サンセリフ)","明朝体(セリフ)");


function hongi_editor_onload(){
    var css_link = document.createElement("link");
    css_link.type = "text/css";
    css_link.rel = "stylesheet";
    css_link.href = hongi_editor_dir_path + "main.css";
    document.getElementsByTagName("head")[0].appendChild(css_link);
    
    hongi_editor_lite_toolbar = document.createElement("div");
    hongi_editor_lite_toolbar.id = "hongi_editor_lite_toolbar";
    hongi_editor_lite_toolbar.onselectstart = function(){ return false; };
    hongi_editor_lite_toolbar.onclick = function(){
        document.getElementById("hongi_editor_wysiwyg_" + hongi_editor_wysiwyg_active).focus();
    };
    
hongi_editor_lite_toolbar.innerHTML = (function(){/*
<a href="javascript: void(0);" onclick="hongi_editor_text_decoration('bold'); return false;" style="font-weight: bold;">太</a><a href="javascript: void(0);" onclick="hongi_editor_text_decoration('italic'); return false;" style="font-style: italic;">斜</a><a href="javascript: void(0);" onclick="hongi_editor_text_decoration('underline'); return false;" style="text-decoration: underline;">下</a><a href="javascript: void(0);" onclick="hongi_editor_text_decoration('strikeThrough'); return false;" style="text-decoration: line-through;">打</a><a href="javascript: void(0);" onclick="hongi_editor_font(); return false;">書体</a><span class="hongi_editor_tool_menu">色<ul><li><a href="javascript: void(0);" onclick="hongi_editor_set_color('#ff0000');" style="color: #ff0000;">赤</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_set_color('#009900');" style="color: #009900;">緑</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_set_color('#0000ff');" style="color: #0000ff;">青</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_set_color('#999999');" style="color: #999999;">灰</a></li></ul></span><span class="hongi_editor_tool_menu">見出<ul><li><a href="javascript: void(0);" onclick="hongi_editor_insert_block('H1'); return false;">H1</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_insert_block('H2'); return false;">H2</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_insert_block('H3'); return false;">H3</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_insert_block('H4'); return false;">H4</a></li></ul></span><span class="hongi_editor_tool_menu">揃え<ul><li><a href="javascript: void(0);" onclick="hongi_editor_alignment('left'); return false;">左</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_alignment('center'); return false;">中央</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_alignment('right'); return false;">右</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_alignment('justify'); return false;">両端</a></li></ul></span><a href="javascript: void(0);" onclick="hongi_editor_link(); return false;"><span style="color: #0000ff; text-decoration: underline;">リンク</span></a><a href="javascript: void(0);" onclick="hongi_editor_img(); return false;">画像</a><span class="hongi_editor_tool_menu">リスト<ul><li><a href="javascript: void(0);" onclick="hongi_editor_ul(); return false;">番号無</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_ol(); return false;">番号付</a></li><li><a href="javascript: void(0);" onclick="hongi_editor_li(); return false;">個項目</a></li></ul></span><a href="javascript: void(0);" onclick="hongi_editor_undo(); return false;">戻す</a><a href="javascript: void(0);" onclick="hongi_editor_redo(); return false;">やり直し</a><a href="javascript: void(0);" onclick="hongi_editor_lite_source(); return false;">ソース</a>
*/}.toString().replace(/(\n)/g," ").split("*")[1]);
    
    document.getElementsByTagName("body")[0].appendChild(hongi_editor_lite_toolbar);
    
    hongi_editor_screen = document.createElement("div");
    hongi_editor_screen.id = "hongi_editor_screen";
    hongi_editor_screen.onselectstart = function(){ return false; };
    
    hongi_editor_screen.innerHTML = (function(){/*
<div id="hongi_editor_font" class="hongi_editor_popup">
    <div class="hongi_editor_popup_close" onclick="hongi_editor_close_screen(); return false;">×</div>
    <b style="font-size: x-large;">書体の指定</b><br>
    <br>
    <b>フォントファミリー</b><br>
    <select id="hongi_editor_font_family"><option value="sans-serif" selected>ゴシック体(サンセリフ)</option></select><br>
    <br>
    <button type="button" style="float: right;" onclick="hongi_editor_font_exec(); return false;">書体の確定</button>
</div>
<div id="hongi_editor_link" class="hongi_editor_popup">
    <div class="hongi_editor_popup_close" onclick="hongi_editor_close_screen(); return false;">×</div>
    <b style="font-size: x-large;">リンクの挿入</b><br>
    <br>
    <b>URL</b>
    <input type="text" id="hongi_editor_a_href"><br>
    <br>
    <button type="button" style="float: right;" onclick="hongi_editor_insert_link(); return false;">挿入</button>
</div>
<div id="hongi_editor_img" class="hongi_editor_popup">
    <div class="hongi_editor_popup_close" onclick="hongi_editor_close_screen(); return false;">×</div>
    <b style="font-size: x-large;">画像の挿入</b><br>
    <br>
    <b>URL</b>
    <input type="text" id="hongi_editor_img_src"><button type="button" id="hongi_editor_browse_image_button" class="hongi_editor_browse_image_button" onclick="hongi_editor_browse_image();">参照</button><br>
    <br>
    <b>説明</b>
    <input type="text" id="hongi_editor_img_alt"><br>
    <br>
    <button type="button" style="float: right;" onclick="hongi_editor_insert_img(); return false;">挿入</button>
</div>
<div id="hongi_editor_ul" class="hongi_editor_popup">
    <div class="hongi_editor_popup_close" onclick="hongi_editor_close_screen(); return false;">×</div>
    <b style="font-size: x-large;">番号なしリストの挿入</b><br>
    <br>
    <b>項目数</b><br>
    <input type="number" id="hongi_editor_ul_li_number" value="5">個<br>
    <br>
    <button type="button" style="float: right;" onclick="hongi_editor_insert_ul(); return false;">挿入</button>
</div>
<div id="hongi_editor_ol" class="hongi_editor_popup">
    <div class="hongi_editor_popup_close" onclick="hongi_editor_close_screen(); return false;">×</div>
    <b style="font-size: x-large;">番号付きリストの挿入</b><br>
    <br>
    <b>項目数</b><br>
    <input type="number" id="hongi_editor_ol_li_number" value="5">個<br>
    <br>
    <button type="button" style="float: right;" onclick="hongi_editor_insert_ol(); return false;">挿入</button>
</div>
<div id="hongi_editor_lite_source" class="hongi_editor_popup">
    <b style="font-size: x-large;">HTMLソースコードの編集</b><br>
    <br>
    <textarea id="hongi_editor_lite_source_area"></textarea><br>
    <br>
    <button type="button" style="float: right;" onclick="hongi_editor_lite_source_close(); return false;">OK</button>
</div>
*/}.toString().replace(/(\n)/g," ").replace(/__DIR_PATH__/g,hongi_editor_dir_path).split("*")[1]);
    
    document.getElementsByTagName("body")[0].appendChild(hongi_editor_screen);
    
    hongi_editor_update_font_list();
    
    var forms = document.getElementsByTagName("form");
    for(cnt = 0; cnt < forms.length; cnt++){
        forms[cnt].addEventListener("submit",hongi_editor_onsubmit);
    }
}

window.addEventListener("load",hongi_editor_onload);

function hongi_editor_add_history(){
    var next_current = (hongi_editor_history_current[hongi_editor_wysiwyg_active] + 1) % hongi_editor_history_limit;
    
    if(document.getElementById("hongi_editor_wysiwyg_" + hongi_editor_wysiwyg_active).innerHTML == hongi_editor_history_rings[hongi_editor_wysiwyg_active][hongi_editor_history_current[hongi_editor_wysiwyg_active]]){
        return false;
    }
    
    hongi_editor_history_rings[hongi_editor_wysiwyg_active][next_current] = document.getElementById("hongi_editor_wysiwyg_" + hongi_editor_wysiwyg_active).innerHTML;
    
    if(next_current == hongi_editor_history_oldest[hongi_editor_wysiwyg_active]){
        hongi_editor_history_oldest[hongi_editor_wysiwyg_active] = (next_current + 1) % hongi_editor_history_limit;
    }
    
    hongi_editor_history_latest[hongi_editor_wysiwyg_active] = next_current;
    hongi_editor_history_current[hongi_editor_wysiwyg_active] = next_current;
}

function hongi_editor_add_history_on_delete(){
    if(hongi_editor_latest_key_is_delete){
        hongi_editor_history_current[hongi_editor_wysiwyg_active] = hongi_editor_history_current[hongi_editor_wysiwyg_active] - 1;
        if(hongi_editor_history_current[hongi_editor_wysiwyg_active] < 0){
            hongi_editor_history_current[hongi_editor_wysiwyg_active] = hongi_editor_history_limit - 1;
        }
    }
    
    hongi_editor_add_history();
}

function hongi_editor_undo(){
    if(hongi_editor_history_current[hongi_editor_wysiwyg_active] == hongi_editor_history_oldest[hongi_editor_wysiwyg_active]){
        alert("これ以上戻せません");
        return false;
    }
    
    var before_current = hongi_editor_history_current[hongi_editor_wysiwyg_active] - 1;
    if(before_current < 0){
        before_current = before_current + hongi_editor_history_limit;
    }
    
    hongi_editor_history_current[hongi_editor_wysiwyg_active] = before_current;
    
    document.getElementById("hongi_editor_wysiwyg_" + hongi_editor_wysiwyg_active).innerHTML = hongi_editor_history_rings[hongi_editor_wysiwyg_active][before_current];
}

function hongi_editor_redo(){
    if(hongi_editor_history_current[hongi_editor_wysiwyg_active] == hongi_editor_history_latest[hongi_editor_wysiwyg_active]){
        alert("これ以上やり直せません");
        return false;
    }
    
    var next_current = (hongi_editor_history_current[hongi_editor_wysiwyg_active] + 1) % hongi_editor_history_limit;
    
    document.getElementById("hongi_editor_wysiwyg_" + hongi_editor_wysiwyg_active).innerHTML = hongi_editor_history_rings[hongi_editor_wysiwyg_active][next_current];
    
    hongi_editor_history_current[hongi_editor_wysiwyg_active] = next_current;
}

function hongi_editor_include(name){
    var cnt = hongi_editor_include_cnt;
    var id = "hongi_editor_area_" + cnt;
    
    var s_elm = document.getElementsByName(name)[0];
    
    document.write("<div id='" + id + "'></div>");
    
    hongi_editor_name.push(name);
    
    document.getElementById(id).innerHTML = (function(){/*
<div contenteditable="true" id="hongi_editor_wysiwyg___CNT__" onfocus="hongi_editor_wysiwyg_focus(__CNT__);" onblur="hongi_editor_on_blur();" onkeydown="return hongi_editor_key_down();" onkeyup="hongi_editor_key_up();" class="hongi_editor_wysiwyg"></div>
    */}.toString().replace(/(\n)/g," ").replace(/__CNT__/g,cnt).split("*")[1]);
    
    document.getElementById(id).className = "hongi_editor_area";
    
    var s_style = window.getComputedStyle(s_elm);
    
    document.getElementById(id).style.width = s_style.width;
    
    var w_elm = document.getElementById("hongi_editor_wysiwyg_" + cnt);
    w_elm.innerHTML = s_elm.value;
    w_elm.onpaste = hongi_editor_paste;
    w_elm.style.height = s_style.height;
    
    document.getElementById(id).appendChild(s_elm);
    s_elm.style.display = "none";
    
    hongi_editor_history_rings[hongi_editor_include_cnt] = new Array(hongi_editor_history_limit);
    hongi_editor_history_rings[hongi_editor_include_cnt][0] = s_elm.value;
    hongi_editor_history_current[hongi_editor_include_cnt] = 0;
    hongi_editor_history_latest[hongi_editor_include_cnt] = 0;
    hongi_editor_history_oldest[hongi_editor_include_cnt] = 0;
    
    hongi_editor_include_cnt++;
}

function hongi_editor_wysiwyg_focus(num){
    if(!hongi_editor_toolbar_visible){
        hongi_editor_toolbar_show();
    }
    
    hongi_editor_wysiwyg_active = num;
    
    document.getElementById("hongi_editor_area_" + num).appendChild(hongi_editor_lite_toolbar);
    hongi_editor_lite_toolbar.style.top = "-" + hongi_editor_lite_toolbar.clientHeight + "px";
}

function hongi_editor_toolbar_show(){
    hongi_editor_lite_toolbar.style.display = "block";
}

function hongi_editor_on_blur(){
    setTimeout(function(){
        if(document.activeElement.className.indexOf("hongi_editor") == -1 && document.activeElement.id.indexOf("hongi_editor") == -1){
            hongi_editor_lite_toolbar.style.display = "none";
	}
    },500);
}

function hongi_editor_kaigyo(){
    var sel_obj = window.getSelection();
    var range = sel_obj.getRangeAt(0);
    
    range.deleteContents();
    
    var lf_node = document.createTextNode("\n");
    range.insertNode(lf_node);
    var kaigyo_node = document.createElement("br");
    range.insertNode(kaigyo_node);
    
    sel_obj.collapse(lf_node,1);
    
    hongi_editor_add_history();
}

function hongi_editor_ime_check(){
    if(!hongi_editor_key_upped){
        hongi_editor_add_history();
        
        hongi_editor_key_upped = true;
    }
}

function hongi_editor_key_down(ev){
    hongi_editor_key_upped = false;
    hongi_editor_key_downed = true;
    var evt = ev || window.event;
    
    if(evt.ctrlKey && evt.keyCode == 90){
        hongi_editor_undo();
        return false;
    }
    
    if(evt.ctrlKey && evt.keyCode == 89){
        hongi_editor_redo();
        return false;
    }
    
    if(evt.keyCode == 13){
        if(evt.srcElement.innerHTML.slice(-4) == "<br>"){
            hongi_editor_kaigyo();
        }else{
            var kaigyo_node = document.createElement("br");
            evt.srcElement.appendChild(kaigyo_node);
            hongi_editor_kaigyo();
        }
        evt.returnValue = false;
        return false;
    }
    
    if(evt.keyCode == 229){
        setTimeout(hongi_editor_ime_check,500);
    }
}

function hongi_editor_key_up(ev){
    hongi_editor_key_upped = true;
    var evt = ev || window.event;
    
    if(!hongi_editor_key_downed){
        hongi_editor_add_history();
    }
    
    if(evt.keyCode == 8){
        hongi_editor_add_history_on_delete();
        
        hongi_editor_latest_key_is_delete = true;
    }else{
        hongi_editor_latest_key_is_delete = false;
    }
    
    hongi_editor_key_downed = false;
}

function hongi_editor_paste(ev){
    hongi_editor_add_history();
    
    var naiyo;
    if(ev != null){
        naiyo = ev.clipboardData.getData('text/plain');
    }else{
        naiyo = window.clipboardData.getData('Text');
    }
    naiyo = naiyo.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/\n/g,"<br>\n").replace(/\r/g,"");
    
    var sel_obj = window.getSelection();
    var range = sel_obj.getRangeAt(0);
    
    range.deleteContents();
    
    var lf_node = document.createTextNode("");
    range.insertNode(lf_node);
    
    var span_node = document.createElement("span");
    span_node.innerHTML = naiyo;
    
    var nodes = span_node.childNodes;
    var kosu = nodes.length;
    
    for(var cnt = kosu - 1; cnt >= 0; cnt--){
        range.insertNode(nodes[cnt]);
    }
    
    sel_obj.collapse(lf_node,0);
    
    hongi_editor_add_history();
    
    return false;
}

function hongi_editor_search_parent_elm(tag_name){
    var sel_obj = window.getSelection();
    var range = sel_obj.getRangeAt(0);
    
    var elm = range.commonAncestorContainer;
    
    for(var cnt = 0; cnt < 8; cnt++){
        if(elm.className != undefined){
            if(elm.className.indexOf("hongi_editor") != -1 || elm.tagName.toUpperCase() == "BODY"){
                return false;
            }else if(elm.tagName.toUpperCase() == tag_name.toUpperCase()){
                return elm;
            }
        }
        
        elm = elm.parentNode;
    }
}

function hongi_editor_set_color(color){
    hongi_editor_add_history();
    
    document.execCommand('foreColor',false,color);
    
    hongi_editor_add_history();
}

function hongi_editor_set_font_size(size){
    hongi_editor_add_history();
    
    var size_val;
    switch(size){
        case "xx-large":
            size_val = 6;
            break;
        case "x-large":
            size_val = 5;
            break;
        case "large":
            size_val = 4;
            break;
        case "medium":
            size_val = 3;
            break;
        case "small":
            size_val = 2;
            break;
        case "x-small":
            size_val = 1;
            break;
    }
    document.execCommand('fontSize',false,size_val);
    
    hongi_editor_add_history();
}

function hongi_editor_text_decoration(decoration){
    hongi_editor_add_history();
    
    document.execCommand(decoration);
    
    hongi_editor_add_history();
}

function hongi_editor_font_exec(){
    hongi_editor_add_history();
    
    var family = document.getElementById("hongi_editor_font_family").value;
    
    hongi_editor_close_screen();
    
    document.execCommand("fontName",false,family);
    
    hongi_editor_add_history();
}

function hongi_editor_10_to_16(num10){
    var num16 = Number(num10).toString(16);
    
    if(num16.length <= 1){
        num16 = "0" + num16;
    }
    
    return num16;
}

function hongi_editor_insert_block(tag){
    hongi_editor_add_history();
    
    document.execCommand("formatBlock",false,"<" + tag + ">");
    
    hongi_editor_add_history();
}

function hongi_editor_alignment(align){
    hongi_editor_add_history();
    
    switch(align){
        case "left":
            document.execCommand("justifyLeft");
            break;
        case "center":
            document.execCommand("justifyCenter");
            break;
        case "right":
            document.execCommand("justifyRight");
            break;
        case "justify":
            document.execCommand("justifyFull");
            break;
    }
    
    hongi_editor_add_history();
}

function hongi_editor_insert_link(){
    var el = document.getElementById("hongi_editor_a_href");
    
    if(el.value.length == 0){
        alert("URLが指定されていません！");
    }else{
        hongi_editor_add_history();
        
        hongi_editor_close_screen();
        
        document.execCommand("createLink",false,el.value);
        
        hongi_editor_add_history();
    }
}

function hongi_editor_insert_img(){
    var src = document.getElementById("hongi_editor_img_src");
    var alt = document.getElementById("hongi_editor_img_alt");
    
    if(src.value.length == 0){
        alert("画像のURLが指定されていません！");
    }else{
        hongi_editor_add_history();
        
        hongi_editor_close_screen();
        
        var sel_obj = window.getSelection();
        var range = sel_obj.getRangeAt(0);
        
        range.deleteContents();
        
        var lf_node = document.createTextNode("\n");
        range.insertNode(lf_node);
        var kaigyo_node = document.createElement("br");
        range.insertNode(kaigyo_node);
        
        var img_node = new Image();
        img_node.onload = function(){
            range.insertNode(img_node);
            img_node.alt = alt.value;
            
            if(img_node.naturalWidth > document.getElementById("hongi_editor_wysiwyg_" + hongi_editor_wysiwyg_active).clientWidth){
                img_node.style.width = document.getElementsByName(hongi_editor_name[hongi_editor_wysiwyg_active])[0].style.width;
            }
            
            sel_obj.collapse(lf_node,1);
        }
        img_node.src = src.value;
        
        hongi_editor_add_history();
    }
}

function hongi_editor_insert_ul(){
    hongi_editor_add_history();
    
    var kosu = Number(document.getElementById("hongi_editor_ul_li_number").value);
    
    var list_node = document.createElement("ul");
    
    var list_naiyo = "\n";
    
    for(var cnt = 0; cnt < kosu; cnt++){
        list_naiyo = list_naiyo + "<li></li>\n";
    }
    
    hongi_editor_close_screen();
    
    var sel_obj = window.getSelection();
    var range = sel_obj.getRangeAt(0);
    
    range.deleteContents();
    
    var lf_node = document.createTextNode("\n");
    range.insertNode(lf_node);
    range.insertNode(list_node);
    
    list_node.innerHTML = list_naiyo;
    
    hongi_editor_add_history();
}

function hongi_editor_insert_ol(){
    hongi_editor_add_history();
    
    var kosu = Number(document.getElementById("hongi_editor_ol_li_number").value);
    
    var list_node = document.createElement("ol");
    
    var list_naiyo = "\n";
    
    for(var cnt = 0; cnt < kosu; cnt++){
        list_naiyo = list_naiyo + "<li></li>\n";
    }
    
    hongi_editor_close_screen();
    
    var sel_obj = window.getSelection();
    var range = sel_obj.getRangeAt(0);
    
    range.deleteContents();
    
    var lf_node = document.createTextNode("\n");
    range.insertNode(lf_node);
    range.insertNode(list_node);
    
    list_node.innerHTML = list_naiyo;
    
    hongi_editor_add_history();
}

function hongi_editor_show_screen(){
    var sel_obj = window.getSelection();
    hongi_editor_selection_range = sel_obj.getRangeAt(0);
    
    hongi_editor_screen.style.display = "block";
    
    var ima = new Date();
    var s_time = ima.getTime();
    
    var keika = 0;
    
    var i_id = setInterval(function(){
        ima = new Date();
        keika = (ima.getTime() - s_time) / 10;
        
        if(keika >= 30){
            clearInterval(i_id);
            hongi_editor_screen.style.opacity = "1";
        }else{
            hongi_editor_screen.style.opacity = keika / 30;
        }
    },10);
}

function hongi_editor_close_screen(){
    hongi_editor_popup_number = 0;
    
    var sel_obj = window.getSelection();
    sel_obj.removeAllRanges();
    sel_obj.addRange(hongi_editor_selection_range);
    
    var ima = new Date();
    var s_time = ima.getTime();
    
    var keika = 0;
    
    var i_id = setInterval(function(){
        ima = new Date();
        keika = (ima.getTime() - s_time) / 10;
        
        if(keika >= 30){
            clearInterval(i_id);
            hongi_editor_screen.style.opacity = "0";
            hongi_editor_screen.style.display = "none";
            for(var cnt = 0; cnt < document.getElementsByClassName("hongi_editor_popup").length; cnt++){
                document.getElementsByClassName("hongi_editor_popup")[cnt].style.display = "none";
            }
        }else{
            hongi_editor_screen.style.opacity = 1 - keika / 30;
        }
    },10);
}

function hongi_editor_font(){
    hongi_editor_show_screen();
    document.getElementById("hongi_editor_font").style.display = "block";
}

function hongi_editor_update_font_list(){
    var kosu = hongi_editor_font_family_list.length;
    var naiyo ="<option value='" + hongi_editor_font_family_list[0] + "' style='font-family: " + hongi_editor_font_family_list[0] + ";' selected>" + hongi_editor_font_name_list[0] + "</option>";
    for(var cnt = 1; cnt < kosu; cnt++){
        naiyo = naiyo + "<option value='" + hongi_editor_font_family_list[cnt] + "' style='font-family: " + hongi_editor_font_family_list[cnt] + ";'>" + hongi_editor_font_name_list[cnt] + "</option>";
    }
    
    document.getElementById("hongi_editor_font_family").innerHTML = naiyo;
}

function hongi_editor_add_font_family(family,name){
    hongi_editor_font_family_list.push(family);
    hongi_editor_font_name_list.push(name);
    
    hongi_editor_update_font_list();
}

function hongi_editor_link(){
    hongi_editor_show_screen();
    document.getElementById("hongi_editor_link").style.display = "block";
}

function hongi_editor_img(){
    hongi_editor_show_screen();
    document.getElementById("hongi_editor_img").style.display = "block";
}

function hongi_editor_browse_image(){
    eval(hongi_editor_browse_image_function + "();");
}

function hongi_editor_set_browse_image_function(function_name){
    if(hongi_editor_browse_image_function === ""){
        var style_elm = document.createElement("style");
        style_elm.type = "text/css";
        document.getElementsByTagName("head")[0].appendChild(style_elm);
        
        style_elm.sheet.insertRule("#hongi_editor_browse_image_button{display: inline-block;}",0);
        style_elm.sheet.insertRule("#hongi_editor_img_src{width: 190px; margin-right: 10px;}",1);
    }
    
    hongi_editor_browse_image_function = function_name;
}

function hongi_editor_ul(){
    hongi_editor_show_screen();
    document.getElementById("hongi_editor_ul").style.display = "block";
}

function hongi_editor_ol(){
    hongi_editor_show_screen();
    document.getElementById("hongi_editor_ol").style.display = "block";
}

function hongi_editor_li(){
    var elm = hongi_editor_search_parent_elm("li");
    if(elm === false){
        alert("ここにはリスト要素を挿入できません。");
        return false;
    }
    elm.parentNode.insertBefore(document.createElement("li"),elm.nextSibling);
}

function hongi_editor_onsubmit(){
    for(var cnt = 0; cnt < hongi_editor_include_cnt; cnt++){
        document.getElementsByName(hongi_editor_name[cnt])[0].value = document.getElementById("hongi_editor_wysiwyg_" + cnt).innerHTML;
    }
}

function hongi_editor_lite_source(){
    hongi_editor_add_history();
    
    hongi_editor_show_screen();
    document.getElementById("hongi_editor_lite_source").style.display = "block";
    
    document.getElementById("hongi_editor_lite_source_area").value = document.getElementById("hongi_editor_wysiwyg_" + hongi_editor_wysiwyg_active).innerHTML;
}

function hongi_editor_lite_source_close(){
    hongi_editor_close_screen();
    
    document.getElementById("hongi_editor_wysiwyg_" + hongi_editor_wysiwyg_active).innerHTML = document.getElementById("hongi_editor_lite_source_area").value;
    
    hongi_editor_add_history();
}